//
//  constants_definition.h
//  dtbca_public_release
//
//  Created by Dhruv Batra on 8/25/11.
//  Copyright 2011 Dhruv Batra. All rights reserved.
//

#ifndef __CONSTANTS_DEFINITION_H__
#define __CONSTANTS_DEFINITION_H__

//////////////////////////////////////////////////////////////////
// Parameters

//////////////////////////////////////////////////////////////////
// Which algorithms to run
// -2 : MPLP
// -1 : TRW-S
//  0 : star-TBCA
//  1 : comb-TBCA
//  2 : LPDG-based TBCA
//  3 : WTA(10)-based TBCA
//vector<int> alg_list(1,2); // Run LPDG by default
vector<int> alg_list(1,-1); // Run TRW-S by default
//vector<int> alg_list(1,-2);

// Convergence Criteria
int MAXITER = 100000;
//int MAXTIME = 100000;
int MAXTIME = 7;
double INT_GAP_THRES = 1e-3;
double DUAL_IMPROV_THRES = 1e-10;

// Standard Values
double default_potts_lambda = 20;

// Precision
int MAX_INT = 10000; 
bool en_round = false;
#define INF 100000

typedef int Inttype;
typedef int Labeltype;

// Heuristics for improving message-passing convergence
bool DILATE = true;  // Dilate (or smear) the scores around
int NUM_ITERATIONS_OF_COMBS = 4;  // Run comb-TBCA for this many iterations before switching to LPDG/WTA

// Whether or not to save or load messages
bool LOAD_MESSAGES = false;
bool SAVE_MESSAGES = false;
bool MODIFY_MASK = false;

//////////////////////////////////////////////////////////////////
// Paths
string inputpath = "./data/";
//string inputpath = "/Users/dbatra/my_folders/research/projects/p2_dtrw/public_release/dtbca_v0.92/data/";
string outputpath = "./results";
//string outputpath = "/Users/dbatra/my_folders/research/projects/p2_dtrw/public_release/dtbca_v0.92/results/";

#ifdef TYPE_POTTS
string energytype = "Potts";
//string name = "venus383x434";
string name = "tsukuba288x384";
//string name = "cones375x450";
//string name = "teddy375x450";
#else
// string energytype = "General";
string energytype = "UAI";
//string name = "2008_000006";
//string name = "2008_000011";
//string name = "pascal2008_000938";
//string name = "1fpo"; // biggest
//string name = "1awd";  // medium
//string name = "1b67";
//string name = "1c75";
//string name = "1bbz";
//string name = "1brf";
//string name = "1en2";  
//string name = "1kth";  
//string name = "1bx7";  // smallest
//string name = "grid3x3";
string name = "grid3x3_subTrue_e100_0";
#endif
// Extension of energy filename
//string ext = ".txt";
string ext = ".uai";

string mask_filename = "";

#endif
